poj3274--Gold Balanced Lineup(hash)

2024-08-25 01:18

本文主要是介绍poj3274--Gold Balanced Lineup(hash),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Gold Balanced Lineup
Time Limit: 2000MS Memory Limit: 65536K
Total Submissions: 12334 Accepted: 3618

Description

Farmer John's N cows (1 ≤ N ≤ 100,000) share many similarities. In fact, FJ has been able to narrow down the list of features shared by his cows to a list of only K different features (1 ≤ K ≤ 30). For example, cows exhibiting feature #1 might have spots, cows exhibiting feature #2 might prefer C to Pascal, and so on.

FJ has even devised a concise way to describe each cow in terms of its "feature ID", a single K-bit integer whose binary representation tells us the set of features exhibited by the cow. As an example, suppose a cow has feature ID = 13. Since 13 written in binary is 1101, this means our cow exhibits features 1, 3, and 4 (reading right to left), but not feature 2. More generally, we find a 1 in the 2^(i-1) place if a cow exhibits feature i.

Always the sensitive fellow, FJ lined up cows 1..N in a long row and noticed that certain ranges of cows are somewhat "balanced" in terms of the features the exhibit. A contiguous range of cows i..j is balanced if each of the K possible features is exhibited by the same number of cows in the range. FJ is curious as to the size of the largest balanced range of cows. See if you can determine it.

Input

Line 1: Two space-separated integers, N and K.
Lines 2.. N+1: Line i+1 contains a single K-bit integer specifying the features present in cow i. The least-significant bit of this integer is 1 if the cow exhibits feature #1, and the most-significant bit is 1 if the cow exhibits feature # K.

Output

Line 1: A single integer giving the size of the largest contiguous balanced group of cows.

Sample Input

7 3
7
6
7
2
1
4
2

Sample Output

4

Hint

In the range from cow #3 to cow #6 (of size 4), each feature appears in exactly 2 cows in this range


题目大意,按二进制给出一些特征,求最长的一段内的所有特征相同

首先用p[i][j]存储从第一个牛到底i头牛,关于第j种特征的总数,如果某一段中的[i,j]符合,那么

p[j][0] - p[i-1][0] = p[j][1] = p[i-1][1] = 。。 =  p[j][k-1] - p[i-1][k-1];从第0到k-1所有的差都相同,一定是p[j][0...k] - p[i-1][0...k] 才对应的是区间[i,j];

那么,转化后的p[j][1] - p[j][0] = p[i-1][1] - p[i-1][0] , p[j][2] - p[j][0] = p[i-1][2] - p[i-1][0] 。。。。一直k-1

所以最后是p[i][j]转化为p[i][j] = p[i][j] - p[i][0] ;那么如果区间[i,j]相同,那么p[i-1]和p[j]应该完全相同,使用hash找到最长的一段

注意,存在可能区间[1,n]是最长的区间,所以在vec[0] 中加入0

 

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
using namespace std ;
#define mod 999997
int p[110000][32] ;
vector <int> vec[100000] ;
int main()
{
int i , j , n , k , a , c[32] , num , flag , l , h , max1 = 0 ;
__int64 sum ;
scanf("%d %d", &n, &k);
for(i = 0 , num = 1; i < k ; i++)
{
p[0][i] = 0 ; num *= 2 ;
}
sum = 0;
vec[0].push_back(0) ;
for(i = 1 ; i <= n ; i++)
{
scanf("%d", &a);
if(a == num-1)
max1 = 1 ;
j = k-1 ;
memset(c,0,sizeof(c));
while(a)
{
c[j--] = a%2 ;
a /= 2 ;
}
for(j = 0 ; j < k ; j++)
{
p[i][j] = p[i-1][j] + c[j] ;
}
}
for(i = 1 ; i <= n ; i++)
{
sum = 0 ;
for(j = 1 ; j < k ; j++)
{
p[i][j] = p[i][j] - p[i][0] ;
sum += p[i][j] ;
}
p[i][0] = 0 ;
if(sum < 0) sum += 100000 ;
sum %= mod ;
num = vec[sum].size();
flag = 0 ;
for(j = 0 ; j < num ; j++)
{
l = vec[sum][j] ;
for(h = 0 ; h < k ; h++)
if( p[i][h] != p[l][h] )
break;
if(h == k)
{
flag = 1 ;
if( max1 < i-l )
max1 = i-l ;
}
}
if(!flag)
vec[sum].push_back(i) ;
}
printf("%d\n", max1);
}


 

这篇关于poj3274--Gold Balanced Lineup(hash)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1104141

相关文章

学习hash总结

2014/1/29/   最近刚开始学hash,名字很陌生,但是hash的思想却很熟悉,以前早就做过此类的题,但是不知道这就是hash思想而已,说白了hash就是一个映射,往往灵活利用数组的下标来实现算法,hash的作用:1、判重;2、统计次数;

hdu1043(八数码问题,广搜 + hash(实现状态压缩) )

利用康拓展开将一个排列映射成一个自然数,然后就变成了普通的广搜题。 #include<iostream>#include<algorithm>#include<string>#include<stack>#include<queue>#include<map>#include<stdio.h>#include<stdlib.h>#include<ctype.h>#inclu

康拓展开(hash算法中会用到)

康拓展开是一个全排列到一个自然数的双射(也就是某个全排列与某个自然数一一对应) 公式: X=a[n]*(n-1)!+a[n-1]*(n-2)!+...+a[i]*(i-1)!+...+a[1]*0! 其中,a[i]为整数,并且0<=a[i]<i,1<=i<=n。(a[i]在不同应用中的含义不同); 典型应用: 计算当前排列在所有由小到大全排列中的顺序,也就是说求当前排列是第

hdu1496(用hash思想统计数目)

作为一个刚学hash的孩子,感觉这道题目很不错,灵活的运用的数组的下标。 解题步骤:如果用常规方法解,那么时间复杂度为O(n^4),肯定会超时,然后参考了网上的解题方法,将等式分成两个部分,a*x1^2+b*x2^2和c*x3^2+d*x4^2, 各自作为数组的下标,如果两部分相加为0,则满足等式; 代码如下: #include<iostream>#include<algorithm

usaco 1.2 Milking Cows(类hash表)

第一种思路被卡了时间 到第二种思路的时候就觉得第一种思路太坑爹了 代码又长又臭还超时!! 第一种思路:我不知道为什么最后一组数据会被卡 超时超了0.2s左右 大概想法是 快排加一个遍历 先将开始时间按升序排好 然后开始遍历比较 1 若 下一个开始beg[i] 小于 tem_end 则说明本组数据与上组数据是在连续的一个区间 取max( ed[i],tem_end ) 2 反之 这个

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

整数Hash散列总结

方法:    step1  :线性探测  step2 散列   当 h(k)位置已经存储有元素的时候,依次探查(h(k)+i) mod S, i=1,2,3…,直到找到空的存储单元为止。其中,S为 数组长度。 HDU 1496   a*x1^2+b*x2^2+c*x3^2+d*x4^2=0 。 x在 [-100,100] 解的个数  const int MaxN = 3000

POJ 1198 双广+Hash

此题采用双广可从bfs的O(16^8)降低到O(2*16^4); 坐标0-7,刚好3位存储, 需要24位存储四个坐标(x,y),也就是[0,2^24) 。 很好的一题。 import java.io.BufferedReader;import java.io.InputStream;import java.io.InputStreamReader;import

C# Hash算法之MD5、SHA

MD5我们用的还是比较多的,一般用来加密存储密码。但是现在很多人觉MD5可能不太安全了,所以都用上了SHA256等来做加密(虽然我觉得都差不多,MD5还是能玩)。 还是跟上一篇说的一样,当一个算法的复杂度提高的同时肯定会带来效率的降低,所以SHA和MD5比较起来的话,SHA更安全,MD5更高效。 由于HASH算法的不可逆性,所以我认为MD5和SHA主要还是应用在字符串的"加密"上。 由于

CPP中的hash [more cpp-7]

写在前面 hash 在英文中是弄乱的含义。在编程中,hash是一种数据技术,它把任意类型的数据通过算法,生成一串数字(hash code),实现hash的函数称为哈希函数,又称散列函数,杂凑函数。在CPP中hashcode是一个size_t类型的数字。 你可能会问?把数据弄乱有什么用?为什么我们要把数据映射到一串数字上?这又什么意义吗?我们先看看hash的性质 一般hash性质 唯一性(唯